
MEMORY 
{ 
        FLASH (rx) : ORIGIN = 0x08000000, LENGTH = 0x10000 
        SRAM (rwx) : ORIGIN = 0x20000000, LENGTH = 0x2000 
} 

_estack = 0x20001000;

/* Section Definitions */ 
SECTIONS 
{ 
        .text : 
        { 
                KEEP(*(.isr_vector .isr_vector.*)) 
                *(.text .text.*) 
                *(.rodata .rodata*) 
                _etext = .;
                _sidata = .;  
        } > FLASH 

        .data : AT (_etext) 
        { 
                _sdata = .; 
                *(.data .data.*) 
                . = ALIGN(4); 
                _edata = . ;
        } > SRAM 

        /* .bss section which is used for uninitialized data */ 
        .bss (NOLOAD) : 
        { 
                _sbss = . ; 
                *(.bss .bss.*) 
                *(COMMON) 
                . = ALIGN(4); 
                _ebss = . ; 
        } > SRAM 


        . = ALIGN(4); 
        _end = . ; 
} 