#include "py32f0xx.h"

#define DEFAULT_BAUDRATE                  115200            /* Default Baudrate */
#define DEFAULT_BRR                       ((SystemCoreClock+DEFAULT_BAUDRATE/2)/DEFAULT_BAUDRATE)

/**
 * @brief  
 * @note   
 * @retval None
 */
void USART_Init(void)
{
  CLEAR_BIT(GPIOA->MODER, (GPIO_MODER_MODE2_0 | GPIO_MODER_MODE3_0)); //10: 复用功能模式
  SET_BIT(GPIOA->AFR[0], (GPIO_AFRL_AFSEL2_0 | GPIO_AFRL_AFSEL3_0)); //0001:AF1 USART1_TX(PA2) USART1_RX(PA3)

  SET_BIT(RCC->APBENR2, RCC_APBENR2_USART1EN);

  //USART_CR1_M   1： 1 start bit， 9 data bit， n stop bit
  //USART_CR1_PCE 1：奇偶校验使能
  //USART_CR1_PS  0：偶校验(EVEN)
  //USART_CR2_STOP 00： 1 stop bit
  SET_BIT(USART1->CR1, (USART_CR1_M | USART_CR1_PCE));

  WRITE_REG(USART1->BRR, DEFAULT_BRR);

  SET_BIT(USART1->CR1, USART_CR1_UE);//1： USART 使能

  CLEAR_BIT(USART1->SR, (USART_SR_RXNE | USART_SR_TC));
  SET_BIT(USART1->CR1, (USART_CR1_TE | USART_CR1_RE));
}

/**
  * @brief  This function is used to send one byte through USART pipe.
  * @param  ucDataBuf The byte to be sent.
  * @retval None.
  */
void USART_SendByte(uint8_t ucDataBuf)
{
  USART1->SR;//CLEAR_BIT(USART1->SR, USART_SR_TC);
  USART1->DR = (ucDataBuf & (uint16_t)0x01FF);
  while (USART_SR_TC != READ_BIT(USART1->SR, USART_SR_TC));
}

#define __GNUC__
#ifdef __GNUC__
	#define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
	#define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif
PUTCHAR_PROTOTYPE
{
  USART_SendByte(ch&0xFF);
  return ch;
}

int _write(int file, char *ptr, int len)
{
  int DataIdx;
  for (DataIdx=0; DataIdx<len; DataIdx++)
  {
    __io_putchar(*ptr++);
  }
  return len;
}

